<template>
  <svg :width="width" :height="height" class="barChart"> 
    <g class="annotations" :transform="`translate(${width /2}, ${height / 2})`">
      <g class="annotation"  v-for="(c ,i) in ann" :key="i"> 
        <circle :r="c.rad" fill="none" stroke="#ccc" />
        <text class="annotationText" x="0" :y="-c.rad - 7" textAnchor="middle" fill="#ccc"> {{c.temp}}</text> 
      </g>
    </g>
    <g v-for="(l ,i) in line" :key="i" :transform="`translate(${width /2}, ${height / 2})`"> 
      <line x1="0" y="0" :r="c.rad" fill="none" stroke="#ccc" />
    </g>
    <path v-for="bar in bars" 
      :transform="`translate(${width /2}, ${height / 2})`"
      :key="bar.data"
      :d="bar.path" 
      :fill="bar.fill" 
      :data="bar.data"
    />
  </svg>
</template>

<script>
import * as d3 from 'd3' 
import {TweenMax} from 'gsap'

export default {
  props: ['data'],
  data () {
    return {
      width: 400,
      height: 400,
      margin: { top: 25, right: 20, bottom: 25, left: 35 },
      annotations: [-10, -5, 0 ,5 ,10, 15, 20, 25, 30,],
      bars: [],
      ann: []
    }
  },

  methods: {
    calcScales () {
      const colorExtent = d3.extent(this.data, d => d.avg).reverse()
      this.colorScale = d3.scaleSequential()
        .domain(colorExtent)
        .interpolator(d3.interpolateRdYlBu)
 
      this.radiusScale = d3.scaleLinear()
        .domain([-10, 35])
        .range([0, this.width / 2 ])
      
      this.anglePerSlice = (2* Math.PI) / this.data.length 
     },

     calcBars() {
      let path
      const arcGenerator = d3.arc()
      this.bars = this.data.map((d, i)=> { 
        if (this.bars[i]) {
          path = this.bars[i].path
        } else {
          path = arcGenerator({
            startAngle: i * this.anglePerSlice,
            endAngle: ( i +1 ) * this.anglePerSlice,
            innerRadius: this.radiusScale(0),
            outerRadius: this.radiusScale(10),
        })
       }
       const newPath = arcGenerator({
         startAngle: i * this.anglePerSlice,
         endAngle: ( i +1 ) * this.anglePerSlice,
         innerRadius: this.radiusScale(d.low),
         outerRadius: this.radiusScale(d.high),
       })
       return {path, newPath, fill: this.colorScale(d.avg)}
     })
    },

    animate () {
      TweenMax.staggerFromTo(this.bars, .75, {
        // from
        cycle: {
         path : (i) => this.bars[i].path,
        }
      }, {
        // to
        cycle: {
          path : (i) => this.bars[i].newPath,
        },
      })
    },

    renderTempAnnotations () {
      if (this.data.length < 0) {
        this.ann = []
      }
      this.ann = this.annotations.map(d => {
        return {
          rad: this.radiusScale(d),
          temp: `${d}°C`
        }
      })
    },
  },

  computed: {
  },
  watch: {
    data () {
     this.calcScales()
     this.calcBars()
     this.renderTempAnnotations()
     this.animate()
    },
  },
}
</script>

<style>
body {
  background: #383c4a;
}

.xAxis line, .yAxis line {
  stroke: #ccc;
}

.xAxis path, .yAxis path {
  stroke: #ccc;
}

.xAxis text, .yAxis text {
  color: #ccc;
}

.yAxis path, .yGridLines path {
  stroke: none;
}

.yGridLines line {
  stroke: #ccc;
  stroke-width: 1px;
  stroke-opacity: .2;
}

.barChart {
  border: #ccc 0px solid;
}

.annotation > g:nth-child(2) {
  background: green;
}

.annotation:nth-child(2n ) circle {
  stroke-opacity: .2;
}

.annotation:nth-child(2n ) .annotationText {
  display: none; 
}

.annotationText {
  font-size: 10px;
  font-family: sans-serif;
}
</style>
